var debug = true;
var jclist = "1,人教版|2,沪教版";
var njlist = "1,一年级|2,二年级|3,三年级|4,四年级|5,五年级|6,六年级";
var xqlist = "1,上学期|2,下学期";
var bjlist = "0,实验班|1,一班|2,二班|3,三班|4,四班|5,五班|6,六班|7,七班|8,八班|9,九班|10,十班|11,十一班|12,十二班|13,十三班|14,十四班|15,十五班";

$.zeronum = function(num,len){
    if(typeof(num) !== "number"){return;}
    while(num.toString().length < len){
        num = "0" + num;
    }
    return num;
}
$.par2json=function(){
    var obj = {};
    var url = document.location.href;
    var ind = url.indexOf("?");
    if(ind < 0)
        return obj;
    var urlparam = url.substring(url.indexOf("?") + 1);
    pairs = urlparam.split('&');
    $.each(pairs, function(i,pair) {
        ind = pair.indexOf('=');
        if(ind > -1)
        {
            name = decodeURIComponent(pair.substring(0,ind));
            value = decodeURIComponent(pair.substring(ind + 1));
        }
        else
        {
            name = pair;
            valur = null;
        }
        obj[name] = value;
    });
    return obj;
};
function j_substr(str,n,endstr){
    if(endstr === undefined)
        endstr = "...";
  var r=/[^\x00-\xff]/g;
  if(str.replace(r,"mm").length<=n){return str;}
  var m=Math.floor(n/2);
  for(var i=m;i<str.length;i++){
      if(str.substr(0,i).replace(r,"mm").length>=n){
          return str.substr(0,i)+endstr;
      }
  }
  return str;
}

function getint(val, defval) {
    if(defval === undefined)
        defval = 0;
    ret = parseInt(val);
    if(isNaN(ret))
        return defval;
    else if(ret === undefined)
        return defval;
    else
        return ret;
}
function getfloat(val, defval) {
    if(defval == undefined)
        defval = 0;
    ret = parseFloat(val);
    if(isNaN(ret))
        return defval;
    else
        return ret;
}
function getmoney(val) {
    val = parseFloat(val);
    if(isNaN(val))
        return 0;
    val = val.toFixed(2);
    return val.replace(".00","");
}
function loading(act,html) {
    if(act == "show")
    {
        if(html === undefined)
            html = "与服务器交互中，请稍候...";
        btnhtml="<div class='msgbox_loading'>"+html+"</div>";
        $("body").prepend(btnhtml);
        $(".msgbox_loading").show(300);
    }
    else
        $(".msgbox_loading").hide(300,function(){$(".msgbox_loading").remove();});
}
//<999 普通页面，999loading，9000+msgbox
var msgzindex = 9000;
function showmsg(html, btn, cb, option) {
    msgzindex++;
    var zindex = msgzindex;
    if(option === undefined) option = {};
    if(btn == undefined || btn == null || btn == "")
        btn = "确定";
    btns = btn.split(",");
    btnhtml="<div id='msgbox"+zindex+"' class='msgbox' style='z-index:"+zindex+";'><div class='msgbox_box'";
    if(option.style !== undefined)
        btnhtml+=" style='"+option.style+"'";
    btnhtml+="><div class='msgbox_main'><div class='msgbox_content'>"+html+"</div><div class='msgbox_btn'>";
    for(var i=0; i<btns.length; i++)
        btnhtml+="<a class='button'>"+btns[i]+"</a>";
    btnhtml+="</div></div></div></div>";
    $("body").prepend(btnhtml);
    $("#msgbox"+zindex+" .msgbox_box").show(300);
    $("#msgbox"+zindex+" .button").on("tap",function(e){
        try{
            if(typeof(cb)=="function")
            cb($(this).text());
        }catch(e){}
        $("#msgbox"+zindex+" .msgbox_box").hide(300,function(){$("#msgbox"+zindex).remove();});
    });
}

// 字符串转换utf-8
function EncodeUtf8(s1)
{
    // escape函数用于对除英文字母外的字符进行编码。如“Visit W3School!”->"Visit%20W3School%21"
    var s = escape(s1);
    var sa = s.split("%");//sa[1]=u6211
    var retV ="";
    if(sa[0] != "")
    {
        retV = sa[0];
    }
    for(var i = 1; i < sa.length; i ++)
    {
        if(sa[i].substring(0,1) == "u")
        {
            retV += Hex2Utf8(Str2Hex(sa[i].substring(1,5)));
            if(sa[i].length>=6)
            {
                retV += sa[i].substring(5);
            }
        }
        else retV += "%" + sa[i];
    }
    return retV;
}
function Str2Hex(s)
{
    var c = "";
    var n;
    var ss = "0123456789ABCDEF";
    var digS = "";
    for(var i = 0; i < s.length; i ++)
    {
        c = s.charAt(i);
        n = ss.indexOf(c);
        digS += Dec2Dig(eval(n));
        
    }
    //return value;
    return digS;
}
function Dec2Dig(n1)
{
    var s = "";
    var n2 = 0;
    for(var i = 0; i < 4; i++)
    {
        n2 = Math.pow(2,3 - i);
        if(n1 >= n2)
        {
            s += '1';
            n1 = n1 - n2;
        }
        else
            s += '0';
    }
    return s;
}
function Dig2Dec(s)
{
    var retV = 0;
    if(s.length == 4)
    {
        for(var i = 0; i < 4; i ++)
        {
            retV += eval(s.charAt(i)) * Math.pow(2, 3 - i);
        }
        return retV;
    }
    return -1;
}
function Hex2Utf8(s)
{
    var retS = "";
    var tempS = "";
    var ss = "";
    if(s.length == 16)
    {
        tempS = "1110" + s.substring(0, 4);
        tempS += "10" +  s.substring(4, 10);
        tempS += "10" + s.substring(10,16);
        var sss = "0123456789ABCDEF";
        for(var i = 0; i < 3; i ++)
        {
            retS += "%";
            ss = tempS.substring(i * 8, (eval(i)+1)*8);
            retS += sss.charAt(Dig2Dec(ss.substring(0,4)));
            retS += sss.charAt(Dig2Dec(ss.substring(4,8)));
        }
        return retS;
    }
    return "";
}
function callback(returnValue)
{
    //alert("the return value from js:" + returnValue);
}
function testClick(cmd,parameter1,parameter2)
{
    var iframe = document.createElement('iframe');
    iframe.src="objc://"+cmd+":/"+EncodeUtf8(parameter1)+":/"+EncodeUtf8(parameter2);
    iframe.style.width = '1px';
    iframe.style.height = '1px';
    document.body.appendChild(iframe);
    iframe.parentNode.removeChild(iframe);
    iframe = null;
}
function payurl(cmd,parameter1,parameter2,parameter3,parameter4,parameter5)
{
    window.location.href="objc://"+cmd+":/"+EncodeUtf8(parameter1)+":/"+parameter2+":/"+EncodeUtf8(parameter3)+":/"+EncodeUtf8(parameter4)+":/"+EncodeUtf8(parameter5);
}
function cb_ccid(id,returnValue)
{
    callfunc_ex(returnValue,'',callfunc_funcname, callfunc_data, callfunc_successfunc,callfunc_option);
}
var callfunc_funcname;
var callfunc_data;
var callfunc_successfunc;
var callfunc_option;
function callfunc(funcname, data, successfunc,option){
    var ccid = 0;
    if(isios())
    {
        callfunc_funcname=funcname;
        callfunc_data=data;
        callfunc_successfunc=successfunc;
        callfunc_option=option;
        testClick('getccid:',' ','cb_ccid');
    }
    else
    {
        var bean = window.bean;
        if(bean != undefined)
            ccid=bean.JsGetCCid();
        else
            ccid=27;//pc测试用
        callfunc_ex(ccid,'',funcname, data, successfunc,option);
    }
}
function callfunc_ex(ccid,sid,funcname, data, successfunc,option){
    if(option === undefined)
        option = {};
    if(option.showdlg !== false)
        option.showdlg = true;
    if(ispc())
        option.murl = 'http://localfingerabc/exam/ajax.php';
    else
        option.murl = 'http://exam.fingerabc.com/exam/ajax.php';
    if(option.murl === undefined)
        option.murl = 'http://exam.fingerabc.com/exam/ajax.php';
    if(option.showdlg)
        loading("show");
    cb = "cb" + getint(Math.random()*100000);
    $.ajax({"url":option.murl+"?json=true&func="+funcname+"&ccid="+ccid+"&sid=0"
           ,"dataType":"jsonp"
           ,"data":data
           ,"jsonpCallback":cb
           ,"jsonp":"cb"
           ,"timeout":35000
           ,"success":function(json){
           if(json.result)
           {
           if(typeof(successfunc) == "function")
           successfunc(json);
           }
           else
           {
           if(option.showdlg)
           {
           errmsg(json.msg);
           }
           else
           {
           if(typeof(successfunc) == "function")
           successfunc(json);
           }
           }
           }
           ,error:function(xhr, textStatus, errorThrown){
           if(option.showdlg)
           {
                if(textStatus.indexOf("timeout")>-1)
                errmsgstr = "访问超时";
                else if(textStatus.indexOf("error")>-1)
                errmsgstr = "访问失败";
                else
                errmsgstr = "访问错误:" + textStatus;
                showmsg(errmsgstr,"刷新,确定",function(btn){
                    if(btn == "刷新")
                        location.reload();
                });
           }
           else
           {
           if(typeof(successfunc) == "function")
           successfunc({result:false,msg:"出现错误:" + textStatus});
           }
           }
           ,complete :function(){
           if(option.showdlg)
           loading("hide");
           if(option.complete !== undefined)
           option.complete();
           }
    });
}

function isMobile(s)
{
    var patrn=/^[1][0-9]{10}$/;
    if (!patrn.exec(s))
        return false;
    return true;
}
function isEmail (theStr) {
    var atIndex = theStr.indexOf('@');
    var dotIndex = theStr.indexOf('.', atIndex);
    var flag = true;
    theSub = theStr.substring(0, dotIndex+1)
    
    if ((atIndex < 1)||(atIndex != theStr.lastIndexOf('@'))||(dotIndex < atIndex + 2)||(theStr.length <= theSub.length))
    { return(false); }
    else { return(true); }
}
function formattime(dt,bestr)
{
    if(bestr == undefined)
        bestr = "";
    diff = (new Date() - new Date(dt));
    diff = parseInt(diff/1000);
    if(diff < 10)//10秒以内
        return "刚刚";
    if(diff < 60)//60秒以内
        return diff +"秒" + bestr;
    if(diff < 3600)//60分以内
        return parseInt(diff/60) +"分" + bestr;
    if(diff < 86400)//24小时以内
        return parseInt(diff/3600) +"小时";
    if(diff < 2592000)//30天以内
        return parseInt(diff/86400) +"天" + bestr;
    if(diff < 31536000)//12月以内
        return parseInt(diff/2592000) +"月" + bestr;
    return parseInt(diff/31536000) +"年" + bestr;
}
function ispc()
{
    if(location.href.indexOf("localfingerabc") > 0)
        return true;
    return false;
}
function isios()
{
    return !!navigator.userAgent.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/);
}
function isiossh()
{
    if(isios())
        return true;//这里开启和关闭
    return false;
}
function isandroid()
{
    if(navigator.userAgent.indexOf("Android") > 0)
        return true;
    return false;
}

function pr(json)
{
    var temp = "";
    if(Object.prototype.toString.call(json) === "[object Number]")
    {
        temp = "number:\n"+json;
    }
    else if(Object.prototype.toString.call(json) === "[object Function]")
    {
        temp = json;
    }
    else if(Object.prototype.toString.call(json) === "[object Undefined]")
    {
        temp = "undefined!";
    }
    else if(Object.prototype.toString.call(json) === "[object Null]")
    {
        temp = "null!";
    }
    else if(Object.prototype.toString.call(json) === "[object Boolean]")
    {
        temp = "bool:\n"+json;
    }
    else if(Object.prototype.toString.call(json) === "[object String]")
    {
        temp = "string:\n"+json;
    }
    else
    {
        temp = "json:\n"+JSON.stringify(json);
        temp += "\nobject:\n";
        for(var i in json){
            temp += i+":"+json[i]+"\n";
        }
    }
    showmsg("<textarea style='width:100%;height:19em;overflow:scroll;'>"+temp+"</textarea>","",null,{style:"top:0;"});
}
function errmsg(msg)
{
    showmsg("<div class=\"msg_circle\">!</div>"+msg);
}
$.appl = function() {
    var bean = window.bean;
    str = "";
    if(bean != undefined)
        str=bean.getApp();
    //str = "[{\"appname\":\"儿童口算益智游戏\",\"name\":\"com.fingerabc.ksyx\",\"ver\":\"3.1\"}]";
    try
    {
        jsons = JSON.parse(str);
        if(typeof(jsons) == "object")
            return jsons;
    }catch(e){return e;}
    return [];
}
$.appset = function(key, value) {//最多8192字节，utf8汉字算3个字节
    var bean = window.bean;
    if(typeof(value) == "object")
        value = JSON.stringify(value);
    if(bean != undefined)
        bean.JsSet(key,value);
    else
        localStorage.setItem(key,value);
}
$.appget = function(key, defvalue) {
    var bean = window.bean;
    var str = defvalue;
    if(bean != undefined)
        str=bean.JsGet(key);
    else
        str=localStorage.getItem(key);
    if(str == ""||str == "null"|| str == null)
        return defvalue;
    try
    {
        jsons = JSON.parse(str);
        if(typeof(jsons) == "object")
            return jsons;
        else
            return defvalue;
    }catch(e){}
    return defvalue;
}
$.getnetwork = function(){//0 无网络1 GPRS��2 WIFI��3其他
    var bean = window.bean;
    if(bean != undefined)
        return bean.JsNettype();
    return 2;
}
$.download = function(id,url,path,file,callback,lx)
{
    if (isios())
    {
        testClick('downfile:', 'action=DownFile|url=' + url + '|path=' + path + '|file=' + file + '|lx=' + lx + '|callback=' + callback + '|id=' + id + '|end=0', callback);
    }
    else
    {
        var bean = window.bean;
        if (bean != undefined)
            bean.JsDownFile(id, url, path, file, callback, lx);
    }
}
                                       function cb_ccid_share(id,returnvalue)
                                       {
                                       var iframe = document.createElement('iframe');
                                       iframe.src="objc://toweixin::/1:/4:/"+EncodeUtf8(sharetext)+":/"+EncodeUtf8("今天做题出奖励了吗？分享多多，奖励多多")+":/"+EncodeUtf8("http://fingerabc.com/exam/wx.php?ccid="+returnvalue)+":/"+EncodeUtf8("data/app.pngboi");
                                       iframe.style.width = '1px';
                                       iframe.style.height = '1px';
                                       document.body.appendChild(iframe);
                                       iframe.parentNode.removeChild(iframe);
                                       iframe = null;
                                       }
var sharetext = '';
$.share = function(text,imgpath,wpath,x,y,font)//text分享文字，imgpath分享图片(Screenshot截图)，wpath水印文字/图片(.pngboi)，xy水印坐标(1左上0居中-1右下)，font水印文字大小
{
                                       
                                       if (isios())
                                       {
                                       sharetext=text;
                                       testClick('getccid:',' ','cb_ccid_share');
                                       }
                                       else
                                       {
    if(font == undefined || font == null) font = 30;
    if(x == undefined || x == null) x = -1;
    if(y == undefined || y == null) y = -1;
    if(wpath == undefined || wpath == null) wpath = "";
    if(imgpath == undefined || imgpath == null) imgpath = "Screenshot";
    if(text == undefined || text == null) text = "";
    var bean = window.bean;
    if(bean != undefined)
        bean.JsShare(text,imgpath,wpath,x,y,font);
                                       }
}
var paycb;
var paymoney;
var payip;
var paytimer = null;
var paysid = '';
$.pay = function(info,money,payid,cb,type)
{
    paycb = cb;
    paymoney = money;
    payip = '127.0.0.1';
    var d = new Date();
    var spayid = "S" + d.getFullYear().toString().substr(1) + "" + $.zeronum(d.getMonth() + 1, 2) + "" + $.zeronum(d.getDate(), 2) + "" + payid + "" + Math.floor(Math.random() * 80 + 10);
    //弹出支付窗口，支付宝支付、微信支付、微信扫码支付三种
    var channel = window.bean.getQDH();
    if(typeof(type) == "undefined")
    {
        var postparam = "payid="+spayid+"&info="+info+"&channel="+channel;
        callfunc("getwxbarcode",postparam,function(json){
            paysid = spayid;
            paytimer = window.setInterval("PayTimer()",1500);
            payip = json.ip;
            var html='';
            html+='<div id="payaction"><div style="top:2em;">';
            html+='<span style="font-size:1.3em;padding:0.7em 0 0.7em 0;display:inline-block;">请支付 <b>'+money+'</b> 元</span><hr style="height:1px;"/>';
            html+='<div class="btnselect" data-type="ALIPAY" style="width:10em;margin:0.7em;text-align:left;display:inline-block;"><img src="images/ali120.pngboi" style="width:2em;vertical-align:middle;"/><span style="font-size:1.2em;padding:0.5em;">支付宝支付</span></div>';
            html+='<div class="btnselect" data-type="WXPAY" style="width:10em;margin:0.7em;text-align:left;display:inline-block;"><img src="images/wx120.pngboi" style="width:2em;vertical-align:middle;"/><span style="font-size:1.2em;padding:0.5em;">微 信 支 付</span></div>';
            html+='<hr style="height:1px;"/><span style="font-size:1.3em;padding:0.7em 0 0.7em 0;display:inline-block;">请家长 微信扫码支付</span><hr style="height:1px;"/>';
            html+='<div style="width:15em;margin:0.5em;"><img src="http://exam.fingerabc.com/pay/wxpay_mb/qrcode.php?data='+json.data+'" style="width:11em;vertical-align:middle;"/><br/><span style="font-size:1em;padding:0.5em;display:inline-block;">请打开微信扫码完成支付</span></div>';
            html+='</div></div>';
            $("body").prepend(html);
            $(".btnselect").tap(function() {
                $('#payaction').fadeOut(500);
                $.pay(info,money,payid,cb,$(this).data('type'));
            });
        });
        return;
    }
    else if(type == 'ALIPAY')
    {
        if (isios())
            payurl('jspay:', info, money, spayid, "http://exam.fingerabc.com/pay/alipay_mb/notify_url.php", 'PayCallBack');
        else
        {
            var bean = window.bean;
            if (bean != undefined)
                bean.JsPay(info, money, spayid, "http://exam.fingerabc.com/pay/alipay_mb/notify_url.php");
            else
                showmsg(info + " 模拟支付宝充值:" + money + ",充值ID:" + spayid);
        }
    }
    else if(type == 'WXPAY')
    {
        if (isios())
            payurl('jspay:', info, getint(money), spayid, "http://exam.fingerabc.com/pay/wxpay_mb/notify.php", 'PayCallBack');
        else
        {
            var bean = window.bean;
            if (bean != undefined)
            {
                var json = '{"ip":"'+payip+'","plx":"pay","body":"'+info+'","detail":"'+info+'","attach":"'+channel+'","out_trade_no":"'+spayid+'","fee_type":"CNY","total_fee":"'+getint(money*100)+'","goods_tag":"","notify_url":"http://exam.fingerabc.com/pay/wxpay_mb/notify.php"}';
                json=json.replace("'","\'");
                bean.Run('wxpay',json,'Paywxcb');
            }
            else
                showmsg(info + " 模拟微信充值:" + money + ",充值ID:" + spayid);
        }
    }
    html='';
    html+='<div id="payaction"><div>';
    html+='<span style="font-size:1.3em;padding:0.7em 0 2em 0;display:inline-block;">支付操作是否成功？</span><br/>';
    html+='<a class="button" id="btnpass">支付成功</a>';
    html+='<a class="button" id="btnfail">遇到问题</a>';
    html+='</div></div>';
    $("body").prepend(html);
    
    $("#btnpass").tap(function() {
        PayPass(spayid);
    });
    $("#btnfail").tap(function() {
        PayFail('');
    });
}
function PayTimer()
{
    callfunc("getpaystatus","payid="+paysid,function(json){
        if(json.pay)
            PayPass(true);
    },{showdlg:false});
    
}
function Paywxcb(s)
{
    var json = JSON.parse(s);
    if(json.length === 0)
        return;
    if(json.code == "0")
        PayPass();
    else
        PayFail('微信支付已取消');
}
function PayPass(result)
{
    //查询订单是否支付成功
    window.clearInterval(paytimer);
    if(typeof(result) == "undefined")
    {
        callfunc("getpaystatus","payid="+paysid,function(json){
            $("#payaction").fadeOut(500);
            if(json.pay)
            {
                if(typeof(paycb) == 'function')
                    paycb(true);
            }
            else
            {
                gourl('payfail.html');
            }
        });
    }
    else
    {
        $("#payaction").fadeOut(500);
        if(typeof(paycb) == 'function')
            paycb(true);
    }
}
function PayFail(msg)
{
    window.clearInterval(paytimer);
    if(msg == "")
    {
        $("#payaction").fadeOut(500);
        gourl('payfail.html');
    }
    else
    {
        $("#payaction").fadeOut(500);
        showmsg(msg);
    }
}
function PayCallBack(retstr)
{
    if(retstr == "")
        PayPass();
    else
        PayFail(retstr);
    
    
}
$.testfile = function(path)
{
    var bean = window.bean;
    if(bean != undefined)
        return bean.JsTestfile(path);
    return true;
}
function getccidcode(id)
{
    return (id + "" +  $.zeronum(((id*8566)%100),2));
}
function jumphref(id,url)
{
   location.href=url;
}
function gourl(url,param){
    if(url === "back")
    {
        referer = $.appget('referer',["index.html"]);
        returl = referer.pop();
        if(returl === undefined)
            returl = 'index.html';
        $.appset('referer',referer);
        location.href=returl;
    }
    else
    {
        referer = $.appget('referer',["index.html"]);
        if(param === undefined)
            param = location.href;
        referer.push(location.href);
        $.appset('referer',referer);
        location.href=url;
    }
}
var myScroll;
var fastclk;
var firstinit = true;

$(function(){
  $("body").prepend('<div id="mask" style="position: fixed;top:0;left:0;z-index:10000000;width:100%;height:100%;background: transparent"></div>');
  $(".href").tap(function () {
    gourl($(this).data('href'));
    });
  $(".sharebtn").tap(function () {
    $.share("小学课后练习题库，能让孩子主动学习的APP",null,"images/sharewt.pngboi",-1,-1,32);
    });
  $("body").prepend('<a href="javascript:location.reload();" style="position: fixed;top:0em;left:30%;width:40%;z-index:10000001;font-size:1em;height:3em;"></a>');


  });
function getgps()
{
    if(isios())
        testClick('jsloc:','','cb_gps');
    else
    {
        var bean = window.bean;
        if(bean != undefined)
        {
            data = JSON.parse(bean.GetGpsString());
            cb_gps(data.lon,data.lat);
        }
    }
}
function cb_gps(lon,lat)
{
    if(lon == 0 && lat == 0)
        return;
    lon = parseFloat(lon) * 1000000;
    lat = parseFloat(lat) * 1000000;
    $.appset("gps",{"lon":lon,"lat":lat});
}
function init(opn,getcb,cb)
{
    defcss = $.appget("defcss",{"bodyfont":1});
    if(location.href.indexOf('.fingerabc.com') > 0)
    {
        var width = $(window).width();
        defcss.bodyfont = width*1.0/22.0;
    }
    fem = parseFloat(defcss.bodyfont);
    if(isNaN(fem) || fem < 0.01)
        fem = 1;
    fem = getint(fem * 100)/100+0.01;
    $("body").css("font-size",fem);
    if(firstinit)
    {
        firstinit = false;
        fastclk = new FastClick(document.body);
        if(opn.scroll == undefined)opn.scroll = true;
        if(opn.scroll)
        {
            if(opn.scrollauto == undefined)opn.scrollauto = true;
            if(opn.scroll)
            {
                var scrollopn = {
                useTransform: false,
                onBeforeScrollStart: function (e) {
                    var target = e.target;
                    while (target.nodeType != 1) target = target.parentNode;
                    if (target.tagName != 'SELECT' && target.tagName != 'INPUT' && target.tagName != 'TEXTAREA')
                        e.preventDefault();
                }
                };
                if(opn.scrollauto)
                    scrollopn.checkDOMChanges=true;
                if(opn.ScrollMove !== undefined)
                    scrollopn.onScrollMove = opn.ScrollMove;
                document.addEventListener('touchmove', function (e) { e.preventDefault(); }, false);
                if(opn.scrollid == undefined)opn.scrollid = "scrollwarp";
                myScroll = new iScroll(opn.scrollid, scrollopn);
            }
        }
    }
    var mainheight = getcb();
    if(mainheight == 0)
    {
        setTimeout(function(){init(opn,getcb,cb);},10);
        return;
    }
    cb(mainheight);
}
function initlist(opn,cb)
{
    if(opn == undefined)
        opn = {};
    init(opn,function(){return $(".caption").height();},function(mh){
         var width = $(window).width();
         $(".caption").css("top",(width*0.22) + "px");
         $("#scrollwarp").css("opacity",0);
         $("#scrollwarp").css("top","15em");
         $("#scrollwarp").animate({"top":(width*0.22 + mh) + "px","opacity":"1"},200,null,function(){setTimeout("cmask()",200);});
         if(cb != undefined)
         cb();
         });
}
function cmask(){
    $("#mask").hide();
}
function smask(){
    $("#mask").show();
}
function getuserinfo(opn, cb){
    //db：true本地先返回，false，本地不返回；sync,0不更新；1适时更新；2强制更新；
    if(opn.db == undefined)opn.db = true;
    if(opn.sync == undefined)opn.sync = 1;
    if(opn.upgift == undefined)opn.upgift = false;
    if(opn.upbuybook == undefined)opn.upbuybook = false;
    if(opn.db)
    {
        userinfo = $.appget('userinfo',{"_update":new Date("2014-1-1"),"upccid":"0","mobile":"0","type":"0","distid":"0","schoolid":"0","schooljc":"1","truename":"","schoolname":"","paddr":"","pname":"","pmobile":"","xb":"0","money":"0","totalmoney":"0","cashmoney":"0","score":"0","addtimes":new Date(),"logintimes":new Date()});
        userinfo.gift = $.appget('usergift',[]);
        userinfo.buybook = $.appget('buybook',[{"bookid":"1"},{"bookid":"15"},{"bookid":"17"}]);
        userinfo._from = 0;
        if(userinfo._update == undefined)
            userinfo._update = new Date("2014-1-1");
        userinfo.ver = undefined;
        if(cb != undefined)
            cb(userinfo);
    }
    var update = true;
    if(opn.sync == 0)
        update = false;
    if(opn.sync == 1 && ((new Date()).getTime() - (new Date(userinfo._update)).getTime()) < 10000)
        update = false;
    if(update)
    {
        params = "info=true";
        if($.appget('usergift',null) == null || opn.upgift)
            params += "&gift=true";
        if($.appget('buybook',null) == null || opn.upbuybook)
            params += "&buybook=true";
        callfunc("getuserinfo",params,function(json){
            if(json.result)
            {
                if(json.user != undefined)
                {
                    userinfo = json.user;
                    userinfo._update = new Date();
                }
                $.appset('userinfo',userinfo);
                if(json.gift != undefined)
                {
                    userinfo.gift = json.gift;
                    $.appset('usergift',userinfo.gift);
                }
                else
                    userinfo.gift = $.appget('usergift',[]);
                if(json.buybook != undefined)
                {
                    userinfo.buybook = json.buybook;
                    $.appset('buybook',userinfo.buybook);
                }
                else
                    userinfo.buybook = $.appget('buybook',[]);
                userinfo._from = 1;
                if(json.ver !== undefined)
                    userinfo.ver = json.ver;
                if(cb != undefined)
                cb(userinfo);
            }
        },{showdlg:false});
    }
}
function getbookindex(opn, cb){
    //db：true本地先返回，false，本地不返回；sync,0不更新；1适时更新；2强制更新；
    if(opn.db == undefined)opn.db = true;
    if(opn.sync == undefined)opn.sync = 1;
    if(opn.upbooksale == undefined)opn.upbooksale = false;
    if(opn.upbuybook == undefined)opn.upbuybook = false;
    if(opn.money == undefined)opn.money = false;
    if(opn.showdlg == undefined)opn.showdlg = false;
    bookindex = $.appget('bookindex', {"_update":new Date("2014-1-1"),"d":[{"id":"1","jc":"1","nj":"1","xq":"1","title":"数学","vip":"","ver":"3","money":"0","num":"1","adminid":"0"},{"id":"17","jc":"1","nj":"1","xq":"1","title":"英语","vip":"","ver":"3","money":"49","num":"1","adminid":"0"},{"id":"66","jc":"1","nj":"1","xq":"1","title":"语文","vip":"","ver":"3","money":"49","num":"1","adminid":"2"},{"id":"18","jc":"1","nj":"1","xq":"2","title":"英语","vip":"","ver":"3","money":"49","num":"1","adminid":"0"},{"id":"16","jc":"1","nj":"1","xq":"2","title":"语文","vip":"","ver":"5","money":"49","num":"1","adminid":"0"},{"id":"2","jc":"1","nj":"1","xq":"2","title":"数学","vip":"","ver":"3","money":"49","num":"1","adminid":"0"},{"id":"33","jc":"1","nj":"2","xq":"1","title":"英语","vip":"","ver":"3","money":"49","num":"1","adminid":"0"},{"id":"27","jc":"1","nj":"2","xq":"1","title":"语文","vip":"","ver":"5","money":"49","num":"1","adminid":"0"},{"id":"12","jc":"1","nj":"2","xq":"1","title":"数学","vip":"","ver":"3","money":"49","num":"1","adminid":"0"},{"id":"29","jc":"1","nj":"2","xq":"2","title":"语文","vip":"","ver":"5","money":"49","num":"1","adminid":"0"},{"id":"20","jc":"1","nj":"2","xq":"2","title":"数学","vip":"","ver":"3","money":"49","num":"1","adminid":"0"},{"id":"34","jc":"1","nj":"2","xq":"2","title":"英语","vip":"","ver":"3","money":"49","num":"10","adminid":"0"},{"id":"5","jc":"1","nj":"3","xq":"1","title":"语文","vip":"","ver":"5","money":"49","num":"1","adminid":"0"},{"id":"45","jc":"1","nj":"3","xq":"1","title":"数学","vip":"","ver":"5","money":"49","num":"1","adminid":"0"},{"id":"35","jc":"1","nj":"3","xq":"1","title":"英语","vip":"","ver":"3","money":"49","num":"20","adminid":"0"},{"id":"6","jc":"1","nj":"3","xq":"2","title":"语文","vip":"","ver":"5","money":"49","num":"1","adminid":"0"},{"id":"46","jc":"1","nj":"3","xq":"2","title":"数学","vip":"","ver":"3","money":"49","num":"10","adminid":"0"},{"id":"36","jc":"1","nj":"3","xq":"2","title":"英语","vip":"","ver":"3","money":"49","num":"30","adminid":"0"},{"id":"32","jc":"1","nj":"4","xq":"1","title":"数学","vip":"","ver":"5","money":"49","num":"1","adminid":"0"},{"id":"8","jc":"1","nj":"4","xq":"1","title":"语文","vip":"","ver":"1","money":"49","num":"1","adminid":"0"},{"id":"37","jc":"1","nj":"4","xq":"1","title":"英语","vip":"","ver":"3","money":"49","num":"40","adminid":"0"},{"id":"47","jc":"1","nj":"4","xq":"2","title":"数学","vip":"","ver":"3","money":"49","num":"1","adminid":"0"},{"id":"10","jc":"1","nj":"4","xq":"2","title":"语文","vip":"","ver":"5","money":"49","num":"1","adminid":"0"},{"id":"38","jc":"1","nj":"4","xq":"2","title":"英语","vip":"","ver":"3","money":"49","num":"50","adminid":"0"},{"id":"14","jc":"1","nj":"5","xq":"1","title":"数学","vip":"","ver":"5","money":"49","num":"1","adminid":"0"},{"id":"60","jc":"1","nj":"5","xq":"1","title":"语文","vip":"","ver":"5","money":"49","num":"2","adminid":"0"},{"id":"39","jc":"1","nj":"5","xq":"1","title":"英语","vip":"","ver":"3","money":"49","num":"60","adminid":"0"},{"id":"4","jc":"1","nj":"5","xq":"2","title":"数学","vip":"","ver":"3","money":"49","num":"1","adminid":"0"},{"id":"61","jc":"1","nj":"5","xq":"2","title":"语文","vip":"","ver":"5","money":"49","num":"12","adminid":"0"},{"id":"40","jc":"1","nj":"5","xq":"2","title":"英语","vip":"","ver":"3","money":"49","num":"70","adminid":"0"},{"id":"49","jc":"1","nj":"6","xq":"1","title":"语文","vip":"","ver":"5","money":"49","num":"1","adminid":"0"},{"id":"3","jc":"1","nj":"6","xq":"1","title":"数学","vip":"","ver":"5","money":"49","num":"1","adminid":"0"},{"id":"41","jc":"1","nj":"6","xq":"1","title":"英语","vip":"","ver":"3","money":"49","num":"80","adminid":"0"},{"id":"65","jc":"1","nj":"6","xq":"2","title":"数学","vip":"","ver":"3","money":"49","num":"1","adminid":"2"},{"id":"50","jc":"1","nj":"6","xq":"2","title":"语文","vip":"","ver":"5","money":"49","num":"10","adminid":"2"},{"id":"42","jc":"1","nj":"6","xq":"2","title":"英语","vip":"","ver":"3","money":"49","num":"90","adminid":"0"},{"id":"73","jc":"2","nj":"1","xq":"1","title":"数学","vip":"","ver":"1","money":"99","num":"0","adminid":"2"},{"id":"75","jc":"2","nj":"1","xq":"1","title":"英语","vip":"","ver":"1","money":"99","num":"20","adminid":"2"},{"id":"77","jc":"2","nj":"1","xq":"1","title":"语文","vip":"","ver":"1","money":"99","num":"40","adminid":"2"},{"id":"74","jc":"2","nj":"1","xq":"2","title":"数学","vip":"","ver":"1","money":"99","num":"10","adminid":"2"},{"id":"76","jc":"2","nj":"1","xq":"2","title":"英语","vip":"","ver":"1","money":"99","num":"30","adminid":"2"},{"id":"80","jc":"2","nj":"2","xq":"1","title":"数学","vip":"","ver":"1","money":"99","num":"91","adminid":"2"},{"id":"82","jc":"2","nj":"2","xq":"1","title":"英语","vip":"","ver":"1","money":"99","num":"93","adminid":"14"},{"id":"84","jc":"2","nj":"2","xq":"1","title":"语文","vip":"","ver":"1","money":"99","num":"95","adminid":"2"},{"id":"81","jc":"2","nj":"2","xq":"2","title":"数学","vip":"","ver":"1","money":"99","num":"92","adminid":"2"},{"id":"83","jc":"2","nj":"2","xq":"2","title":"英语","vip":"","ver":"1","money":"99","num":"94","adminid":"2"},{"id":"86","jc":"2","nj":"3","xq":"1","title":"数学","vip":"","ver":"1","money":"99","num":"97","adminid":"2"},{"id":"88","jc":"2","nj":"3","xq":"1","title":"英语","vip":"","ver":"1","money":"99","num":"99","adminid":"2"},{"id":"90","jc":"2","nj":"3","xq":"1","title":"语文","vip":"","ver":"1","money":"99","num":"101","adminid":"20"},{"id":"87","jc":"2","nj":"3","xq":"2","title":"数学","vip":"","ver":"1","money":"99","num":"98","adminid":"2"},{"id":"89","jc":"2","nj":"3","xq":"2","title":"英语","vip":"","ver":"1","money":"99","num":"100","adminid":"2"},{"id":"92","jc":"2","nj":"4","xq":"1","title":"数学","vip":"","ver":"1","money":"99","num":"103","adminid":"2"},{"id":"94","jc":"2","nj":"4","xq":"1","title":"英语","vip":"","ver":"1","money":"99","num":"105","adminid":"2"},{"id":"96","jc":"2","nj":"4","xq":"1","title":"语文","vip":"","ver":"1","money":"99","num":"107","adminid":"2"},{"id":"93","jc":"2","nj":"4","xq":"2","title":"数学","vip":"","ver":"1","money":"99","num":"104","adminid":"2"},{"id":"95","jc":"2","nj":"4","xq":"2","title":"英语","vip":"","ver":"1","money":"99","num":"106","adminid":"2"},{"id":"98","jc":"2","nj":"5","xq":"1","title":"数学","vip":"","ver":"1","money":"99","num":"109","adminid":"2"},{"id":"100","jc":"2","nj":"5","xq":"1","title":"英语","vip":"","ver":"1","money":"99","num":"111","adminid":"14"},{"id":"102","jc":"2","nj":"5","xq":"1","title":"语文","vip":"","ver":"1","money":"99","num":"113","adminid":"2"},{"id":"99","jc":"2","nj":"5","xq":"2","title":"数学","vip":"","ver":"1","money":"99","num":"110","adminid":"2"},{"id":"101","jc":"2","nj":"5","xq":"2","title":"英语","vip":"","ver":"1","money":"99","num":"112","adminid":"2"}]});//
    bookindex.buybook = $.appget('buybook',[{"bookid":"1"},{"bookid":"15"},{"bookid":"17"}]);//
    bookindex.booksale = $.appget('booksale',[{"money":888,"zk":0.5},{"money":688,"zk":0.3},{"money":488,"zk":0.2},{"money":188,"zk":0.15},{"money":66,"zk":0.1}]);
    if(bookindex._update == undefined)
        bookindex._update = new Date("2014-1-1");
    if(opn.db)
    {
        bookindex._from = 0;
        if(cb != undefined)
            cb(bookindex);
    }
    var update = true;
    if(opn.sync == 0)
        update = false;
    if(opn.sync == 1 && ((new Date()).getTime() - (new Date(bookindex._update)).getTime()) < 86400000)
        update = false;
    if(update)
    {
        params = "_tmp=";
        if($.appget('buybook',null) == null || opn.upbuybook)
            params += "&buybook=true";
        if($.appget('booksale',null) == null || opn.upbooksale)
            params += "&booksale=true";
        if(opn.money)
            params += "&money=true";
                                       
        callfunc("getbookindex",params,function(json){
                 if(json.result)
                 {
                 bookindex.d = json.data;
                 bookindex._update = new Date();
                 $.appset('bookindex',bookindex);
                 if(json.buybook != undefined)
                 {
                 bookindex.buybook = json.buybook;
                 $.appset('buybook',bookindex.buybook);
                 }
                 if(json.booksale != undefined)
                 {
                 bookindex.booksale = json.booksale;
                 $.appset('booksale',bookindex.booksale);
                 }
                 if(json.money != undefined)
                 {
                    userinfo = $.appget('userinfo',null);
                    if(userinfo != null)
                    {
                        if(userinfo.money != json.money)
                            $.appset('userinfo',userinfo);
                    }
                 }
                 bookindex._from = 1;
                 if(cb != undefined)
                 cb(bookindex);
                 }
                 },{showdlg:opn.showdlg});
    }
}
function getgift(giftid, cb){
    giftinfo = $.appget('gift_'+giftid,null);
    showdlg = false;
    if(cb != undefined)
        showdlg = true;
    if(giftinfo != null)
    {
        if(cb != undefined)
            cb(giftinfo);
    }
    params = "giftid="+giftid;
    callfunc("getgift",params,function(json){
             if(json.result)
             {
             giftinfo = json.gift;
             $.appset('gift_'+giftid,giftinfo);
             giftinfo.giftsave = true;
             if(cb != undefined)
             cb(giftinfo);
             }
             },{showdlg:showdlg});
}
function giftstatus(buyccid,stat,style)
{
    //-1埋藏但没生效，0埋藏，10满足条件，11已兑现，20已审核，25已发货，30已收货
    if(style >= 100)//实物奖品
    {//10满足条件，20已发货，30已兑换
        if(stat < 20)//10
            return "已准备好礼物";
        else if(stat < 30)//20
            return "已寄出礼物";
        else if(stat < 100)//30
            return "礼物已被签收";
        else if(stat >= 100)//100
            return "礼物异常，请联系客服";
    }
    else
    {
        if(buyccid == 0)//官方提供的虚拟奖品
        {
            if(stat < 30)//10
                return "已准备好礼物";
            else if(stat < 100)//30
                return "礼物已兑换成功";
            else if(stat >= 100)//100
                return "礼物兑换异常，请联系客服";
            return "官方提供的虚拟奖品["+stat+"]";
        }
        else//家长的许诺奖品
        {
            if(stat == 10)
                return "请展示给家长吧";
            if(stat > 10)//11
                return "家长已经兑现啦";
            return "家长的许诺奖品["+stat+"]";
        }
    }
}